org.objectweb.asm.tree.analysis

## Class Interpreter<V extends Value>

- java.lang.Object
- - org.objectweb.asm.tree.analysis.Interpreter<V>

- Type Parameters:
    `V` - type of the Value used for the analysis.
  Direct Known Subclasses:
    BasicInterpreter, SourceInterpreter

      public abstract class Interpreter<V extends Value>
      extends Object

  A semantic bytecode interpreter. More precisely, this interpreter only manages the computation of values from other values: it does not manage the transfer of values to or from the stack, and to or from the local variables. This separation allows a generic bytecode `Analyzer` to work with various semantic interpreters, without needing to duplicate the code to simulate the transfer of values.
  Author:
    Eric Bruneton

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `api`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `Interpreter(int api)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract V` | `binaryOperation(AbstractInsnNode insn, V value1, V value2)` Interprets a bytecode instruction with two arguments.
    `abstract V` | `copyOperation(AbstractInsnNode insn, V value)` Interprets a bytecode instruction that moves a value on the stack or to or from local variables.
    `abstract V` | `merge(V v, V w)` Merges two values.
    `abstract V` | `naryOperation(AbstractInsnNode insn, List<? extends V> values)` Interprets a bytecode instruction with a variable number of arguments.
    `abstract V` | `newOperation(AbstractInsnNode insn)` Interprets a bytecode instruction without arguments.
    `abstract V` | `newValue(Type type)` Creates a new value that represents the given type.
    `abstract void` | `returnOperation(AbstractInsnNode insn, V value, V expected)` Interprets a bytecode return instruction.
    `abstract V` | `ternaryOperation(AbstractInsnNode insn, V value1, V value2, V value3)` Interprets a bytecode instruction with three arguments.
    `abstract V` | `unaryOperation(AbstractInsnNode insn, V value)` Interprets a bytecode instruction with a single argument.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### api

          protected final int api

  - ### Constructor Detail

    - #### Interpreter

          protected Interpreter(int api)

  - ### Method Detail

    - #### newValue

          public abstract V newValue(Type type)

      Creates a new value that represents the given type. Called for method parameters (including `this`), exception handler variable and with `null` type for variables reserved by long and double types.
      Parameters:
        `type` - a primitive or reference type, or `null` to represent an uninitialized value.
      Returns:
        a value that represents the given type. The size of the returned value must be equal to the size of the given type.

    - #### newOperation

          public abstract V newOperation(AbstractInsnNode insn)
                                  throws AnalyzerException

      Interprets a bytecode instruction without arguments. This method is called for the following opcodes: ACONST_NULL, ICONST_M1, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, LCONST_0, LCONST_1, FCONST_0, FCONST_1, FCONST_2, DCONST_0, DCONST_1, BIPUSH, SIPUSH, LDC, JSR, GETSTATIC, NEW
      Parameters:
        `insn` - the bytecode instruction to be interpreted.
      Returns:
        the result of the interpretation of the given instruction.
      Throws:
        `AnalyzerException` - if an error occured during the interpretation.

    - #### copyOperation

          public abstract V copyOperation(AbstractInsnNode insn,
                                          V value)
                                   throws AnalyzerException

      Interprets a bytecode instruction that moves a value on the stack or to or from local variables. This method is called for the following opcodes: ILOAD, LLOAD, FLOAD, DLOAD, ALOAD, ISTORE, LSTORE, FSTORE, DSTORE, ASTORE, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, SWAP
      Parameters:
        `insn` - the bytecode instruction to be interpreted.
        `value` - the value that must be moved by the instruction.
      Returns:
        the result of the interpretation of the given instruction. The returned value must be `equal` to the given value.
      Throws:
        `AnalyzerException` - if an error occured during the interpretation.

    - #### unaryOperation

          public abstract V unaryOperation(AbstractInsnNode insn,
                                           V value)
                                    throws AnalyzerException

      Interprets a bytecode instruction with a single argument. This method is called for the following opcodes: INEG, LNEG, FNEG, DNEG, IINC, I2L, I2F, I2D, L2I, L2F, L2D, F2I, F2L, F2D, D2I, D2L, D2F, I2B, I2C, I2S, IFEQ, IFNE, IFLT, IFGE, IFGT, IFLE, TABLESWITCH, LOOKUPSWITCH, IRETURN, LRETURN, FRETURN, DRETURN, ARETURN, PUTSTATIC, GETFIELD, NEWARRAY, ANEWARRAY, ARRAYLENGTH, ATHROW, CHECKCAST, INSTANCEOF, MONITORENTER, MONITOREXIT, IFNULL, IFNONNULL
      Parameters:
        `insn` - the bytecode instruction to be interpreted.
        `value` - the argument of the instruction to be interpreted.
      Returns:
        the result of the interpretation of the given instruction.
      Throws:
        `AnalyzerException` - if an error occured during the interpretation.

    - #### binaryOperation

          public abstract V binaryOperation(AbstractInsnNode insn,
                                            V value1,
                                            V value2)
                                     throws AnalyzerException

      Interprets a bytecode instruction with two arguments. This method is called for the following opcodes: IALOAD, LALOAD, FALOAD, DALOAD, AALOAD, BALOAD, CALOAD, SALOAD, IADD, LADD, FADD, DADD, ISUB, LSUB, FSUB, DSUB, IMUL, LMUL, FMUL, DMUL, IDIV, LDIV, FDIV, DDIV, IREM, LREM, FREM, DREM, ISHL, LSHL, ISHR, LSHR, IUSHR, LUSHR, IAND, LAND, IOR, LOR, IXOR, LXOR, LCMP, FCMPL, FCMPG, DCMPL, DCMPG, IF_ICMPEQ, IF_ICMPNE, IF_ICMPLT, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ACMPEQ, IF_ACMPNE, PUTFIELD
      Parameters:
        `insn` - the bytecode instruction to be interpreted.
        `value1` - the first argument of the instruction to be interpreted.
        `value2` - the second argument of the instruction to be interpreted.
      Returns:
        the result of the interpretation of the given instruction.
      Throws:
        `AnalyzerException` - if an error occured during the interpretation.

    - #### ternaryOperation

          public abstract V ternaryOperation(AbstractInsnNode insn,
                                             V value1,
                                             V value2,
                                             V value3)
                                      throws AnalyzerException

      Interprets a bytecode instruction with three arguments. This method is called for the following opcodes: IASTORE, LASTORE, FASTORE, DASTORE, AASTORE, BASTORE, CASTORE, SASTORE
      Parameters:
        `insn` - the bytecode instruction to be interpreted.
        `value1` - the first argument of the instruction to be interpreted.
        `value2` - the second argument of the instruction to be interpreted.
        `value3` - the third argument of the instruction to be interpreted.
      Returns:
        the result of the interpretation of the given instruction.
      Throws:
        `AnalyzerException` - if an error occured during the interpretation.

    - #### naryOperation

          public abstract V naryOperation(AbstractInsnNode insn,
                                          List<? extends V> values)
                                   throws AnalyzerException

      Interprets a bytecode instruction with a variable number of arguments. This method is called for the following opcodes: INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC, INVOKEINTERFACE, MULTIANEWARRAY and INVOKEDYNAMIC
      Parameters:
        `insn` - the bytecode instruction to be interpreted.
        `values` - the arguments of the instruction to be interpreted.
      Returns:
        the result of the interpretation of the given instruction.
      Throws:
        `AnalyzerException` - if an error occured during the interpretation.

    - #### returnOperation

          public abstract void returnOperation(AbstractInsnNode insn,
                                               V value,
                                               V expected)
                                        throws AnalyzerException

      Interprets a bytecode return instruction. This method is called for the following opcodes: IRETURN, LRETURN, FRETURN, DRETURN, ARETURN
      Parameters:
        `insn` - the bytecode instruction to be interpreted.
        `value` - the argument of the instruction to be interpreted.
        `expected` - the expected return type of the analyzed method.
      Throws:
        `AnalyzerException` - if an error occured during the interpretation.

    - #### merge

          public abstract V merge(V v,
                                  V w)

      Merges two values. The merge operation must return a value that represents both values (for instance, if the two values are two types, the merged value must be a common super type of the two types. If the two values are integer intervals, the merged value must be an interval that contains the previous ones. Likewise for other types of values).
      Parameters:
        `v` - a value.
        `w` - another value.
      Returns:
        the merged value. If the merged value is equal to `v`, this method must return `v`.